
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>控件UI性能调优 -- SizeChanged不是万能的 / iVAN</title>

    <meta name="description" content="控件UI性能调优 -- SizeChanged不是万能的 原文:控件UI性能调优 -- SizeChanged不是万能的 简介 我们在之前的&quot;UWP控件开发--用NuGet包装自己的控件&quot;一文中曾提到XAML的布局系统 和平时使用上的一些问题(重写Measure/Arrange还是使用SizeChanged?),这篇博文就来为大家简单地描述一下XAML布局系统的行为,并且归纳几个规则.当然真正的XAML布局系统十分复杂,本文无意把情况弄得太复杂,就从一个最简单最直观的例子入手,来为大家提供一点理解XAML布局的新思路.   问题描述 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">控件UI性能调优 -- SizeChanged不是万能的</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文:<a href="http://www.cnblogs.com/ms-uap/p/5311133.html" rel="external nofollow noreferrer">控件UI性能调优 -- SizeChanged不是万能的</a></p>
<h1>简介</h1>
<p>我们在之前的“<a href="http://www.cnblogs.com/ms-uap/p/5298972.html" rel="external nofollow noreferrer">UWP控件开发——用NuGet包装自己的控件</a>“一文中曾提到XAML的布局系统 和平时使用上的一些问题（重写Measure/Arrange还是使用SizeChanged？），这篇博文就来为大家简单地描述一下XAML布局系统的行为，并且归纳几个规则。当然真正的XAML布局系统十分复杂，本文无意把情况弄得太复杂，就从一个最简单最直观的例子入手，来为大家提供一点理解XAML布局的新思路。</p>
<p> </p>
<h1>问题描述</h1>
<p>假设我们有一个Templated Control，其XAML描述如下：</p>
<pre>&lt;Style TargetType="local:CustomControl1"&gt;
    &lt;Setter Property="Template"&gt;
        &lt;Setter.Value&gt;
            &lt;ControlTemplate TargetType="local:CustomControl1"&gt;
                &lt;Border x:Name="OuterBorder"
                    BorderBrush="Yellow"
                    BorderThickness="20"&gt;
                    &lt;Border x:Name="InnerBorder"
                                BorderThickness="20"
                                BorderBrush="Red" /&gt;
                &lt;/Border&gt;
            &lt;/ControlTemplate&gt;
        &lt;/Setter.Value&gt;
    &lt;/Setter&gt;
&lt;/Style&gt;</pre>
<p>两个Border嵌套，边宽20。我们的目的就是通过代码来改变InnerBorder的大小。比如长宽都变成OuterBorder的一半大。</p>
<p> </p>
<h1>首次尝试</h1>
<p>我们很容易就写出了这样的代码：</p>
<pre>public sealed class CustomControl1 : Control
{
    public CustomControl1() {...}

    private Border _border;
    private Border _inner;
    protected override void OnApplyTemplate()
    {
        base.OnApplyTemplate();

        _border = GetTemplateChild("OuterBorder") as Border;
        _inner = GetTemplateChild("InnerBorder") as Border;
        if (_border != null &amp;&amp; _inner != null)
        {
            _border.SizeChanged += (s, e) =&gt; {
                _inner.Width = _border.ActualWidth / 2;
                _inner.Height = _border.ActualHeight / 2;
            };
        }
    }
}</pre>
<p>works perfectly。这一实现很好地达到了我们的需求。（而且对于这样的简单的情况设计器还是能够正常处理的）</p>
<p> </p>
<h2>对SizeChanged的概述</h2>
<p>但是这却隐藏着问题。首先，SizeChanged事件是由一轮Measure/Arrange完成后触发的。</p>
<p>XAML的核心布局流程，是从根元素 即页面开始，递归向下。第一次挨个调用Measure，提供能用的大小，并确定每个子项所希望的空间大小；再来一次挨个调用Arrange，提供能用大小，按实际情况给子项分配空间（不一定能满足它们的需要）和确定位置。本例的过程中就涉及到OuterBorder和InnerBorder，它们以此能根据Border类布局规则确定自己的大小，即刨去BorderThickness。</p>
<p> </p>
<p>这之后，OuterBorder和InnerBorder的<strong>实际</strong>大小就确定了。如果和上次布局的结果不一样，OuterBorder就会触发SizeChanged事件（是Chang*<strong>ed*</strong>哦），改变InnerBorder的<strong>设定</strong>大小。因为设定大小变化了，会引发新一轮递归Measure和Arrange。这一次之后，OuterBorder的大小不变，InnerBorder的大小变成OuterBorder的一半。之后没有事件和布局再被触发，大家相安无事。</p>
<p>但实际上，布局进行了两轮。如果Visual Tree很大的话，后果可想而知。</p>
<p> </p>
<h1>修改后的过程</h1>
<p>那么，根据我们刚才介绍的过程，从Measure出发，实现如下（去掉SizeChanged的事件绑定并override MeasureOvrride方法）：</p>
<pre>public sealed class CustomControl1 : Control
{
    public CustomControl1() {...}

    private Border _border;
    private Border _inner;
    protected override void OnApplyTemplate()
    {
        base.OnApplyTemplate();

        _border = GetTemplateChild("Border") as Border;
        _inner = GetTemplateChild("InnerBorder") as Border;
    }

    protected override Size MeasureOverride(Size availableSize)
    {
        // availableSize就是OuterBorder的大小
        if (_inner != null)
        {
            _inner.Width = availableSize.Width / 2;
            _inner.Height = availableSize.Height / 2;
        }

        return base.MeasureOverride(availableSize);
    }
}</pre>
<p>设定大小后再进入真正的measure环节，一次性搞定布局。原因就在于我们在布局开始之前就搞定了Size信息，而不是在布局结束后再把它辛辛苦苦计算出来的Size踩在地上并让它重来一遍。在我们设定的需求看来，甚至无需插手Arrange流程。</p>
<p>当然，这免不了地要自己计算Size，可能需要手动减去BorderThickness的大小，甚至还可能要自行调用一次Measure。复杂的具体情况需要具体分析。</p>
<p> </p>
<h1>性能对比</h1>
<p>通过调试工具，我们来对比一下两种方法的实际性能：</p>
<table>
<tbody>
<tr>
<td><strong>SizeChanged</strong></td>
<td><strong>MeasureOverride</strong></td>
</tr>
<tr>
<td><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19kOTQ4NTFkMGE3MjQyMmVmNGY4YTg2NTdhMDU3NjcwMi5wbmc=.jpg"></td>
<td><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ182NWVmZDE5ZTJjZDc2YWE5M2IxZmE1NWEyYmU4YTY4ZS5wbmc=.jpg"></td>
</tr>
<tr>
<td><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18zOGQ0NzYwY2JmOGQ3N2FlNGQzOWY0MTQzNzMyMTZkMS5wbmc=.jpg"></td>
<td><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19mM2VmMWFhMWEwODE5ZWQxN2U5ZmUwNjQ0NWEyN2RhNi5wbmc=.jpg"></td>
</tr>
</tbody>
</table>
<p>在两种实现下，分别大力地快速拖动窗口大小。。。</p>
<p>其中柱形图是一段时间内UI线程的响应情况，占最大比重的橙色是布局行为。下面的扇形图是选中差不多的时间段内，布局消耗的占比情况。</p>
<p>可见通过提供Measure策略的方式，即使是这样简单的设定，性能提升也还看得出来。</p>
<p> </p>
<p>如果我们发扬奥卡姆剃刀的精神，不要自己写这陌生的MeasureOverride，用Grid来做如何？</p>
<pre>&lt;Grid&gt;
    &lt;Grid.ColumnDefinitions&gt;
        &lt;ColumnDefinition Width="*"/&gt;
        &lt;ColumnDefinition Width="2*"/&gt;
        &lt;ColumnDefinition Width="*"/&gt;
    &lt;/Grid.ColumnDefinitions&gt;
    &lt;Grid.RowDefinitions&gt;
        &lt;RowDefinition Height="*"/&gt;
        &lt;RowDefinition Height="2*"/&gt;
        &lt;RowDefinition Height="*"/&gt;
    &lt;/Grid.RowDefinitions&gt;
    &lt;Border x:Name="Border"
            BorderBrush="Yellow"
            BorderThickness="20"
            Grid.RowSpan="3" Grid.ColumnSpan="3"/&gt;
    &lt;Border x:Name="InnerBorder"
            BorderThickness="20"
            BorderBrush="Red"
            Grid.Column="1" Grid.Row="1"/&gt;
&lt;/Grid&gt;</pre>
<p>OnApplyTemplate和MeasureOverride都可以不要了，整个code behind十分清爽。行为看起来差不多，那么性能呢？</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ184ZDZmMmUzNGQ2ZmYyM2IzZDIxZmY0NWE5YzhhYzg2Zi5wbmc=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18yNjNjZjVkN2Q2YzlmMDg1MmE3OGY3OTNiOTg2YTFhOC5wbmc=.jpg"></p>
<p>想必Grid作为标准控件，优化得应该很好了，但它本身就有一点复杂，和MesureOverride的实现在性能上有一点点差距。但毕竟我们这样简单的例子对于Grid太不公平了，对于更为复杂的情况，还是要使用Grid的。</p>
<p> </p>
<h1>总结</h1>
<p>说了这么多，主要是表现一下不必要的布局对于性能的影响，以及对于这样的简单情况如何替代原有实现。</p>
<p>对于布局有影响的操作大致有：</p>
<ul>
<li>改变大小：设置Width、Height、MaxHeight（如果影响到ActualHeight），或者修改Margin、Thickness等</li>
<li>改变内容：设置Content、ContentTemplate、DataTemplate、TextBox.Text等</li>
<li>改变某些属性：如Visible、Orientation、Image.Stretch等</li>
<li>手动调用布局方法：InvalidateMeasure、UpdateLayout等</li>
</ul>
<p>如果调用了这些属性方法，就需要顾虑一下是否会造成不必要的布局了，特别是在SizeChanged这样的由布局触发的事件里。当然这也是一般论，如果控件本来就隐藏了，或者Template改变了原有外型，这些内容也自然随之变化。</p>
<p>P.S. RenderTransform是不造成重新布局的。</p>
<p> </p>
<p>另外，就本文的例子来说，并不是要大家都把SizeChanged改写成MeasureOverride。</p>
<p>MeasureOverride给了一个好处，就是第一时间获知高层布局的相关信息，也就能赶在布局前最后设置一次属性；SizeChanged能给出复杂布局计算后的最新尺寸，如果自己来计算的话没有意义。总之还是要因地制宜。</p>
<p> </p>
<p>虽然本文的例子十分简单，可能没有多少实际意义，不过希望通过它介绍的流程，能为大家的开发提供一点新的思路。</p>
<p> </p>
<h2>参考</h2>
<p>[1] 开源的WPF中的Border.MeasureOverride实现：<a href="http://referencesource.microsoft.com/#PresentationFramework/src/Framework/System/Windows/Controls/Border.cs,00c166b0e025bc8d" rel="external nofollow noreferrer">http://referencesource.microsoft.com/#PresentationFramework/src/Framework/System/Windows/Controls/Border.cs,00c166b0e025bc8d</a></p>
<p>[2] WPF中的Grid.MeasureOverride实现：<a href="http://referencesource.microsoft.com/#PresentationFramework/src/Framework/System/Windows/Controls/Grid.cs,f9ce1d6be154348a" rel="external nofollow noreferrer">http://referencesource.microsoft.com/#PresentationFramework/src/Framework/System/Windows/Controls/Grid.cs,f9ce1d6be154348a</a></p>
<p>[3] SizeChanged事件参考：<a href="https://msdn.microsoft.com/en-us/library/windows/apps/windows.ui.xaml.frameworkelement.sizechanged" rel="external nofollow noreferrer">https://msdn.microsoft.com/en-us/library/windows/apps/windows.ui.xaml.frameworkelement.sizechanged</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-05 11:26:04</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e5%b8%83%e5%b1%80/" title="布局">布局</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>控件UI性能调优 -- SizeChanged不是万能的的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGJ6Dop.html" rel="bookmark">Android界面性能调优手册</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				注:本文是我在 Android 界面性能调优知识的系统性总结,纯属个人碎碎念.秉持开源分享的原则发布本文出来,各位看官有需则取.原文见:https://androidtest.org/android-graphics-performance-pattens/ 界面是 Android 应用中直接影响用户体验最关键的部分.如果代码实现得不好,界面容易发生卡顿且导致应用占用大量内存. 我司这类做 ROM 的公司更不一样,预装的应用一定要非常流畅,这样给客户或用户的第一感觉就是快.又卡又慢的应用体验,会			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWyQWp.html" rel="bookmark">iOS应用性能调优的25个建议和技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文来自iOS Tutorial Team 的 Marcelo Fabri,他是Movile的一名 iOS 程序员.这是他的个人网站:http://www.marcelofabri.com/,你还可以在Twitter上关注@marcelofabri_. 性能对 iOS 应用的开发尤其重要,如果你的应用失去反应或者很慢,失望的用户会把他们的失望写满App Store的评论.然而由于iOS设备的限制,有时搞好性能是一件难事.开发过程中你会有很多需要注意的事项,你也很容易在做出选择时忘记考虑性能影响.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2PrlQp.html" rel="bookmark">PHP 性能分析（三）&colon; 性能调优实战</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在本系列的 第一篇 中,我们介绍了 XHProf .而在 第二篇 中,我们深入研究了 XHGui UI, 现在最后一篇,让我们把 XHProf /XHGui 的知识用到工作中! 性能调优 不用运行的代码才是绝好的代码.其他只是好的代码.所以,性能调优时,最好的选择是首先确保运行尽可能少的代码. OpCode 缓存 首先,最快且最简单的选择是启用 OpCode 缓存.OpCode 缓存的更多信息可以在 这里 找到. 在上图,我们看到启用 Zend OpCache 后发生的情况.最后一行是我们的基准			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj75P5M.html" rel="bookmark">Java EE应用程序在Glassfish上的性能调优案例分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java EE应用的性能问题对严肃的项目和产品来说是一个非常重要的问题.特别是企业级的应用,并发用户多,数据传输量大,业务逻辑复杂,占用系统资源多,因此性能问题在企业级应用变得至关重要,它和系统的稳定性有着直接的联系.更加重要的是,性能好的应用在完成相同任务的条件下,能够占用更少的资源,获得更好的用户体验,换句话说,就是能够节省费用和消耗,获得更高的利润. 要获得更好的性能,就需要对原来的系统进行性能调优.对运行在Glassfish上的JavaEE应用,调优是一件相对复杂的事情.在调优以前必须要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOldV8b.html" rel="bookmark">ANDROID性能调优</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://www.trinea.cn/android/android-performance-demo/#comment-115 本文主要分享自己在appstore项目中的性能调优点,包括同步改异步.缓存.Layout优化.数据库优化.算法优化.延迟执行等.   性能优化专题已完成五部分: 性能优化总纲--性能问题及性能调优方式性能优化第三篇--Java(Android)代码优化性能优化第二篇--布局优化性能优化第一篇--数据库性能优化 性能优化实例    一.性能瓶颈点 整个页面主要由6个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrXWnjz.html" rel="bookmark">Android性能调优工具TraceView介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android自带的TraceView堪比java的性能调优工具visualvm线程视图,可以方便的查看线程的执行情况,某个方法执行时间.调用次数.在总体中的占比等,从而定位性能点.1.生成日志,运行TraceView 运行TraceView有两种方式a.调用Debug类 在开始调试的地方,如Activity的onCreate函数,添加 Java 1 Debug.startMethodTracing(&quot;tracefilename&quot;); 结束调试的地方,如Activity的onDestr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rq2Nz.html" rel="bookmark">性能调优攻略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于性能优化这是一个比较大的话题,在&lt;由12306.cn谈谈网站性能技术&gt;中我从业务和设计上说过一些可用的技术以及那些技术的优缺点,今天,想从一些技术细节上谈谈性能优化,主要是一些代码级别的技术和方法.本文的东西是我的一些经验和知识,并不一定全对,希望大家指正和补充. 在开始这篇文章之前,大家可以移步去看一下以前发表的&lt;代码优化概要&gt;,这篇文章基本上告诉你--要进行优化,先得找到性能瓶颈!但是在讲如何定位系统性能瓶劲之前,请让我讲一下系统性能的定义和测试,因为没有这两件事,后面的定			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0REDPz.html" rel="bookmark">【Xamarin挖墙脚系列：应用的性能调优】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:[Xamarin挖墙脚系列:应用的性能调优] 官方提供的工具:网盘地址:http://pan.baidu.com/s/1pKgrsrp 官方下载地址:https://download.xamarin.com/profiler/profiler-windows.msi Xamarin Profiler,使用此工具,帮助我们进行软件性能的调优,找到应用的瓶颈. 内存占用较高的代码调用进行监视.快速解决影响程序性能的代码.   关于此工具的使用,请参见: https://developer.xa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxY1xjp.html" rel="bookmark">《T-SQL性能调优秘笈&mdash;&mdash;基于SQL Server 2012 窗口函数》&mdash;&mdash;1&period;6　窗口定义的重复使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.6 窗口定义的重复使用 T-SQL性能调优秘笈--基于SQL Server 2012 窗口函数 假设我们需要在同一个查询中调用多个窗口函数,并且部分窗口描述(或所有描述)适用于多个函数.如果我们在所有函数中都给出完整的窗口描述,代码的长度会急速增加,从下面的示例中可以看到问题: 标准SQL对此有解决方法,它有一个叫做WINDOW的子句,允许我们对窗口描述或部分窗口描述进行命名:然后在定义其他窗口--即将被窗口函数使用或用来定义另一个命名窗口时,指代这个命名的窗口描述.从概念上来说,这个子句在			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnBxKp.html" rel="bookmark" class="title">优秀站长工具推荐之网站反链查询</a>
					<div>
						做网站SEO,网站外链的重要性毋庸置疑.就是因为外链对网站的SEO影响非常大,所以百度站长平台最新公布的绿萝算法,才会加大对非法外链买卖的打击力度. 以前在业内最常用的是雅虎外链查询工具,能查询一个网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6KVNp.html" rel="bookmark" class="title">Oracle与PHP实例开发Myers订单跟踪系统</a>
					<div>
						关于 PHP/Oracle 开发模型如何在Myers Internet缩短应用程序生命周期的案例研究. 对于主要由应收款业务模型驱动的公司而言,其核心的业务功能之一是输入.跟踪和记录订单.在这方面比较 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnyRmz.html" rel="bookmark" class="title">一个典型的Windows窗体程序实例</a>
					<div>
						/*Form1.cs文件*/ using System; using System.Collections.Generic; using System.ComponentModel; using Sy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElrXZz.html" rel="bookmark" class="title">WCF后续之旅（7）：通过WCF Extension实现和Enterprise Library</a>
					<div>
						松耦合.高内聚是我们进行设计的永恒的目标,如何实现这样的目标呢?我们有很多实现的方式和方法,不管这些方式和方法在表现形式上有什么不同,他们的思想都可以表示为:根据稳定性进行关注点的分离或者分解,交互双 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0P9KnM.html" rel="bookmark" class="title">百度卫士抢票专版软件怎么抢&quest;</a>
					<div>
						  百度卫士抢票专版软件是百度官方推出的一款快捷抢票软件,不少朋友马上就要开始抢2016春运春节火车票了,那么百度卫士抢票专版软件就可以帮助你抢票哦,那么百度卫士抢票专版软件怎么抢2016春运春节火车 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo650Bz.html" rel="bookmark" class="title">什么是psd分层素材</a>
					<div>
						1.PSD分层素材可以理解为模型.道具,你可以把每一层进行上下.左右. 前后的调整或者组合进其它背景(场景中),会非常方便的调整组合.而不分层的(一般是指位图图片格式)即便我们用软件把每个物件扣出来, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62xjgM.html" rel="bookmark" class="title">天天动听网页版打不开怎么办</a>
					<div>
						  天天动听是一款非常好的播放器,小编一直都在用,但是偶尔也会出现一些问题,比如说网页版的音乐打不开,下面小编就以这个问题为例给大家分享一下小编个人的经验吧,希望能够帮助到大家. 天天动听网页版打不开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLa40vz.html" rel="bookmark" class="title">新浪微博如何找到热门话题？</a>
					<div>
						  使用电脑登录的用户,点击微博首页右侧&quot;热门话题&quot;模块,可快速查看当日热门话题. 话题首页可以按照分类查看热门话题.推荐话题. 发微博加上&quot;#话题词#&quot;,发布 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EGlXM.html" rel="bookmark" class="title">苹果电脑怎么安装双系统</a>
					<div>
						    选择这两项,如果你已经安装好MACOSX10.10.3的系统,只需要购买WIN8.1即可,如果还想备用MACOSX系统,可以选择Win8.1+OSX10.10.3双系统 您好,在您收到我们U盘 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQAKYp.html" rel="bookmark" class="title">软件工程疑问-win10系统usb转串口驱动安装不上怎么回事？有没有朋友知道&hellip;&hellip;</a>
					<div>
						问题描述 win10系统usb转串口驱动安装不上怎么回事?有没有朋友知道-- win10系统usb转串口驱动安装不上怎么回事?有没有朋友知道-- 是驱动不对? 解决方案 可以尝试用驱动精灵,驱动人生安 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwQ8jp.html" rel="bookmark" class="title">mfc进度条颜色怎么更改呢？我错在哪里，因该怎么改？</a>
					<div>
						问题描述 mfc进度条颜色怎么更改呢?我错在哪里,因该怎么改? m_progress.SendMessage(PBM_SETBARCOLOR, 0, (LPARAM)RGB(123, 0, 0));  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NqVNM.html" rel="bookmark" class="title">一个关于代码规范的小问题</a>
					<div>
						问题描述 例: 变量名studentID正确吗 , D要不要大写 ? 本来根据驼峰命名法就不合规范了, 可是我看到官方代码上又大写了. 迷惑, 我是学生 . 问题补充:babydeed 写道 解决方案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd3Dkb.html" rel="bookmark" class="title">android侧滑菜单的状态栏一体化怎么去实现呢</a>
					<div>
						问题描述 android侧滑菜单的状态栏一体化怎么去实现呢 xml代码: android:fitsSystemWindows=&quot;true&quot; android:clipToPaddin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKVwjb.html" rel="bookmark" class="title">七岁的OpenStack成熟了？企业就绪了？</a>
					<div>
						中国福利彩票发行管理中心(以下简称福彩中心)今年开始启用了一个新的云计算平台,这是一个基于OpenStack的私有云解决方案,用于支持其福利彩票的日常管理和运营.目前,福彩中心技术人员正在将业务逐渐向 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDlR8z.html" rel="bookmark" class="title">《Servlet和JSP学习指南》一1&period;10　处理HTML表单</a>
					<div>
						1.10 处理HTML表单 每个Web应用程序中几乎都会包含一个或者多个HTML表单,用来接收用户输入.你可以轻松地将一个HTML表单从Servlet发送到浏览器.当用户提交表单时,在表单元素中输入的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydV6Zb.html" rel="bookmark" class="title">java-求解答，页面登录问题</a>
					<div>
						问题描述 求解答,页面登录问题 我设计了一个网页登录系统,使用servlet+JSP来编写,数据库使用MySQL,使用jdbc操作,我想在此请教下各位,怎么保存登录的账号,使其在跳转到另一个页面的时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlK65Vb.html" rel="bookmark" class="title">王东进：大健康产业既是良心产业，又是爱心产业</a>
					<div>
						投资畿朿9日消息,今天由清科集团主办的第四届中国医疗健康产业投资与并购大会在北京举行〿/p&gt; 图为国务院参事室特约研究员.中国医疿a href=&quot;http://news.pedaily ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjL45np.html" rel="bookmark" class="title">背水一战 Windows 10 &lpar;52&rpar; - 控件（集合类）&colon; ItemsControl - 自定义 ItemsControl&comma; 自定义 ContentPresenter</a>
					<div>
						原文:背水一战 Windows 10 (52) - 控件(集合类): ItemsControl - 自定义 ItemsControl, 自定义 ContentPresenter [源码下载] 背水一战 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RN4Wz.html" rel="bookmark" class="title">土豆优酷联手可能影响视频行业广告价格</a>
					<div>
						3月12日消息,优酷土豆今日合并成立新公司,公司合并后,优酷.土豆仍将独立发展,广告界人士表示,由于目前尚不清楚新公司的业务销售模式及版权采购政策,因此,对合并后优酷和土豆两个平台的广告投放策略不会有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwo76M.html" rel="bookmark" class="title">MongoDB短连接Auth性能优化</a>
					<div>
						通常我们使用MongoDB的时候,客户端(driver)和MongoDB之间都是使用长连接,但是在某些场景下.某些driver仍然只能使用短连接进行连接,比如PHP.就在我们阿里云数据库MongoDB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZB4xkz.html" rel="bookmark" class="title">有一段传奇  叫提高班</a>
					<div>
						十四年斗转星移动   十四年大江东去 提高班告诉你一个地球的惊喜 提高班告诉你一个东方的奇迹 我想约你行走在彩虹里 那是提高班正在穿越世界屋脊 那是提高班通向天际的呼吸 那是提高班衔接科技海洋的蔚蓝色 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze06w7p.html" rel="bookmark" class="title">XML 如何设置属性啊？</a>
					<div>
						问题描述 &lt;bookgenre=&quot;novel&quot;publicationdate=&quot;1982&quot;bk:ISBN=&quot;1-861001-45-3&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkd3kM.html" rel="bookmark" class="title">基于JavaScript 类的使用详解&lowbar;基础知识</a>
					<div>
						以下为构造函数方法创建类: 复制代码 代码如下: function className (prop_1, prop_2, prop_3) {  this.prop1 = prop_1;  this.p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44Kq8z.html" rel="bookmark" class="title">由于查询条件比较多，查询后跳转到另一页面，如何吧这些查询条件传到结果页面，有什么好的方法？</a>
					<div>
						问题描述 由于查询条件比较多,查询后跳转到另一页面,如何吧这些查询条件传到结果页面,有什么好的方法? 解决方案 解决方案二:是ASP.NET2.0么?如果是服务器按钮控件有个postbackurl这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWdB5ep.html" rel="bookmark" class="title">无须装软件&colon;随时随地玩Web版Gtalk</a>
					<div>
						很多朋友都在玩Google推出的Google Talk(简称Gtalk)软件,用它来与朋友http://www.aliyun.com/zixun/aggregation/12498.html&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVdLnlM.html" rel="bookmark" class="title">限制只能输入中文，英文，数字，标点的正则表达式（最好是全角和半角都可以）</a>
					<div>
						问题描述 限制只能输入中文,英文,数字,标点的正则表达式(最好是全角和半角都可以),高人指典啊!谢谢了. 解决方案 解决方案二:高人快回答啊!解决方案三:不熟正则.帮顶--					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrvn2mM.html" rel="bookmark" class="title">ThinkPHP云引擎版本发布 从3&period;0版本新增SAE引擎</a>
					<div>
						从3.0版本的SAE引擎开始,ThinkPHP已经开始支持云平台,但是随着国内不同的云平台风起云涌,不同的云引擎也容易给开发者造成了不少的困惑,2013年新年伊始,官方推出了针对所有云平台和分布式系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR7R33p.html" rel="bookmark" class="title">struts 2什么东西可以代替struts1&period;x中的actionform</a>
					<div>
						问题描述 rt:最好来个传送门...在线等 解决方案 解决方案二:struts2中的成员变量加get.set方法,struts1中的actionform功能一样都是传递参数解决方案三:引用楼主java ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQax7ob.html" rel="bookmark" class="title">实验八</a>
					<div>
						1.实验名称:实验八 文件拷贝 2.实验时间:2008-6-13 3.实验目的:编程用面向对象设计思想分析.设计并实现实验八的内容. 4.实验内容:利用c++文件操作函数实现文件,将text1.txt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnOkDAz.html" rel="bookmark" class="title">关于java中list构造函数的问题</a>
					<div>
						问题描述 java中list的构造函数list(introws,booleanmultipleMode),第一个参数rows是定义显示的项数,也就是说如果这样定义list(4,false)之后,列表中 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
